<template>
  <table v-if="picrossData">
    <tr
      v-for="row in picrossData.size.rows + 1"
      :key="'r' + row"
    >
      <td
        v-for="column in picrossData.size.columns + 1"
        :key="'r' + row + 'c' + column"
        :class="isCellSelected(row, column) ? 'selected' : ''"
        @click="toggleCell(row, column)"
      >
        <span v-if="row === 1 && column > 1">
          {{ picrossData.data.columns[column - 2].join(' ') }}
        </span>
        <span v-else-if="row > 1 && column === 1">
          {{ picrossData.data.rows[row - 2].join(' ') }}
        </span>
      </td>
    </tr>
  </table>
</template>
<script>
import PicrossEditor from './PicrossEditor.vue'

export default {
  name: 'PicrossPlayer',
  extends: PicrossEditor,
  props: {
    picrossData: Object
  },
  computed: {
    isPicrossFinished () {
      if (!this.picrossData) return false
      const {
        data: {
          rows: currentRows,
          columns: currentColumns
        }
      } = this.nonogramData

      const {
        data: {
          rows: picrossRows,
          columns: picrossColumns
        }
      } = this.picrossData

      const currentRowsJoined = currentRows.map(cr => cr.join('-')).join('|')
      const currentColumnsJoined = currentColumns.map(cr => cr.join('-')).join('|')
      const picrossRowsJoined = picrossRows.map(cr => cr.join('-')).join('|')
      const picrossColumnsJoined = picrossColumns.map(cr => cr.join('-')).join('|')
      return currentRowsJoined === picrossRowsJoined && currentColumnsJoined === picrossColumnsJoined
    }
  },
  methods: {
    createCellsValuesArray () {
      if (!this.picrossData) return
      this.makeCellsValuesArray(this.picrossData.size.rows, this.picrossData.size.columns)
    }
  },

  watch: {
    isPicrossFinished (newValue) {
      if (newValue === true) {
        this.$emit('victory')
      }
    },
    picrossData () {
      this.makeCellsValuesArray(this.picrossData.size.rows, this.picrossData.size.columns)
    }
  }
}

</script>
